unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Registry;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function AutoPlayLigado: Boolean;
var
  Reg: TRegistry;
  AutoRun : integer;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    Reg.OpenKey('Software\Microsoft\Windows\'+
      'CurrentVersion\Policies\Explorer', false);
    Reg.ReadBinaryData('NoDriveTypeAutoRun', AutoRun ,
      sizeof(Integer));
    Result := not ((AutoRun and (1 shl 5)) <> 0);
    Reg.CloseKey;
  finally
    Reg.Free;
  end;  
end;

procedure SetaAutoPlay(Liga : Boolean);
var
  Reg: TRegistry;
  AutoRun : integer;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    Reg.OpenKey('Software\Microsoft\Windows\'+
      'CurrentVersion\Policies\Explorer', false);
    Reg.ReadBinaryData('NoDriveTypeAutoRun', AutoRun,
      sizeof(Integer));
    if Liga then
      AutoRun := AutoRun and not (1 shl 5)
    else
      AutoRun := AutoRun or (1 shl 5);
    Reg.WriteBinaryData('NoDriveTypeAutoRun', AutoRun,
      sizeof(Integer));
    Reg.CloseKey;
  finally
    Reg.free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if AutoPlayLigado then
    ShowMessage('AutoPlay Ligado')
  else
    ShowMessage('AutoPlay Desligado');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SetaAutoPlay(True);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  SetaAutoPlay(False);
end;

end.
 